# drone_cd means drone cooldown. Expect Drone Cooldown to last about the same as Melvin's healing bubble ability, as the drone kamikaze ability is very powerful.
scoreboard objectives add drone_cd dummy
scoreboard players add @a drone_cd 0
scoreboard players add @a[scores={drone_cd=1..,drone_phase=0},tag=playing] drone_cd 1
execute as @a[scores={drone_cd=1500},tag=playing] run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Batteries are at 25%.","italic":true,"color":"gray"}]
execute as @a[scores={drone_cd=3000},tag=playing] run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Batteries are at 50%.","italic":true,"color":"gray"}]
execute as @a[scores={drone_cd=4500},tag=playing] run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Batteries are at 75%.","italic":true,"color":"gray"}]
execute as @a[scores={drone_cd=4500},tag=playing] at @s run playsound minecraft:test.outage.drone_charging player @s ~ ~ ~ 0.5 1 0.01
execute as @a[scores={drone_cd=6000..},tag=playing] run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Batteries are recharged.","italic":true,"color":"white"}]
execute as @a[scores={drone_cd=6000..},tag=playing] at @s run playsound minecraft:test.outage.drone_charged player @s ~ ~ ~ 0.5 1 0.01
scoreboard players set @a[scores={drone_cd=6000..}] drone_cd 0

#
# The momentum of the drone carries over to the player when the drone dies. This is BAD. If the drone was flying up, and then it explodes, the player is teleported back but then they start flying up using the remaining momentum. To fix this,
# A barrier is placed above the player when they are teleported back. Sadly, if the barrier is removed within the same tick, it means NOTHING. The player must collide with it to cancel the momentum. So this scoreboard exists purely to wait a
# whole tick before removing the barrier.

scoreboard objectives add drone_barrier dummy
scoreboard players add @a drone_barrier 0
execute as @a[scores={drone_barrier=1}] at @s run fill ~5 ~5 ~5 ~-5 ~0 ~-5 air replace barrier
execute unless entity @a[scores={drone_barrier=2..}] run execute as @a[scores={PosY=..44},gamemode=adventure,tag=playing] at @s run fill ~5 ~5 ~5 ~-5 ~0 ~-5 air replace barrier
execute as @a[scores={drone_barrier=1..}] at @s run scoreboard players remove @s drone_barrier 1

#
#

# Areas where drones are not allowed
tag @a[tag=no_drone] remove no_drone
execute as @a[scores={recruit=2,drone_cd=0},tag=playing] at @s if blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked if entity @a[scores={PosX=88..138,PosY=19..43,PosZ=-42..24}] run tag @s add no_drone
execute as @a[scores={recruit=2,drone_cd=0},tag=playing] at @s if blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked if entity @a[scores={PosX=52..121,PosY=28..56,PosZ=-57..23}] run tag @s add no_drone

execute as @a[scores={recruit=2,drone_cd=0,drone_phase=0},nbt={SelectedItem:{id:"minecraft:warped_fungus_on_a_stick"}}] unless entity @s[tag=no_drone] at @s if blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked run title @s actionbar [{"text":"READY","color":"green","italic":"true"}]
execute as @a[scores={recruit=2,drone_cd=0,drone_phase=0},nbt={SelectedItem:{id:"minecraft:warped_fungus_on_a_stick"}}] unless entity @s[tag=no_drone] at @s unless blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked run title @s actionbar [{"text":"NOT ENOUGH ROOM","color":"yellow","italic":"true"}]
execute as @a[scores={recruit=2,drone_cd=0,drone_phase=0},nbt={SelectedItem:{id:"minecraft:warped_fungus_on_a_stick"}}] if entity @s[tag=no_drone] run title @s actionbar [{"text":"TRY ANOTHER AREA","color":"red","italic":"true"}]

execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=1..},tag=playing] at @s run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Batteries are being recharged.","italic":true,"color":"red"}]
execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=1..},tag=playing] at @s run playsound entity.villager.no player @s ~ ~ ~ 0.5 1 0.01
execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=1..},tag=playing] at @s run scoreboard players set @s drone_phase 0
execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=0},tag=playing] at @s if blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked if entity @a[tag=no_drone] run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Drone cannot be deployed here, try somewhere else.","italic":true,"color":"red"}]
execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=0},tag=playing] at @s if blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked if entity @a[tag=no_drone] run playsound entity.villager.no player @s ~ ~ ~ 0.5 1 0.01
execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=0},tag=playing] at @s if blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked if entity @a[tag=no_drone] run scoreboard players set @s drone_phase 0
execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=0},tag=playing] at @s if blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked unless entity @a[tag=no_drone] run playsound minecraft:test.outage.drone_deploy player @a ~ ~ ~ 0.5 1 0.01
execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=0},tag=playing] at @s if blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked unless entity @a[tag=no_drone] run function spark:deploy
execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=0},tag=playing] at @s unless blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Not enough room to deploy drone.","italic":true,"color":"red"}]
execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=0},tag=playing] at @s unless blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked run playsound entity.villager.no player @s ~ ~ ~ 0.5 1 0.01
execute as @a[scores={recruit=2,rclick_special=1..,drone_cd=0},tag=playing] at @s unless blocks ~-1 ~3 ~-1 ~1 ~1 ~1 0 0 0 masked run scoreboard players set @s drone_phase 0
scoreboard objectives add drone_phase dummy
scoreboard players add @a drone_phase 0

execute as @a[scores={recruit=2,drone_phase=1},tag=playing] at @s anchored eyes positioned ^ ^ ^0.5 run teleport @e[name=drone,type=armor_stand,limit=1,sort=nearest] ~ ~-1.5 ~ ~ ~
execute as @a[scores={recruit=2,drone_phase=1},tag=playing] at @s anchored eyes positioned ^ ^ ^0.5 unless block ~ ~ ~ air run playsound minecraft:test.outage.drone_miss player @s ~ ~ ~ 0.5 1 0.01
execute as @a[scores={recruit=2,drone_phase=1},tag=playing] at @s anchored eyes positioned ^ ^ ^0.5 unless block ~ ~ ~ air run scoreboard players set @s drone_phase 2
execute as @a[scores={recruit=2,drone_phase=1},tag=playing] at @s anchored eyes positioned ^ ^ ^0.5 if entity @e[type=zombie,distance=..3] run playsound minecraft:test.outage.drone_hit player @s ~ ~ ~ 0.5 1 0.01
execute as @a[scores={recruit=2,drone_phase=1},tag=playing] at @s anchored eyes positioned ^ ^ ^0.5 if entity @e[type=zombie,distance=..3] run scoreboard players set @s drone_phase 2
execute as @a[scores={recruit=2,drone_phase=1},tag=playing] at @s anchored eyes positioned ^ ^ ^0.5 if entity @e[type=warden,distance=..6] run playsound minecraft:test.outage.drone_hit player @s ~ ~ ~ 0.5 1 0.01
execute as @a[scores={recruit=2,drone_phase=1},tag=playing] at @s anchored eyes positioned ^ ^ ^0.5 if entity @e[type=warden,distance=..6] run scoreboard players set @s drone_phase 2
execute as @a[scores={recruit=2,drone_phase=1,randomd=1},tag=playing] at @s run playsound minecraft:entity.bee.loop player @s ^ ^-0.1 ^0.5 0.5 2 0.5

execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run execute as @e[name=pilot,type=armor_stand,limit=1,sort=nearest] at @s rotated as @s run tp @a[scores={recruit=2,drone_phase=2},tag=playing] ~ ~ ~ ~ ~
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run gamemode adventure @s
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @e[type=armor_stand,name=drone,tag=drone,limit=1,sort=nearest] run playsound minecraft:entity.firework_rocket.large_blast_far player @a ~ ~ ~ 2 0.1 0.2
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @e[type=armor_stand,name=drone,tag=drone,limit=1,sort=nearest] run summon minecraft:creeper ~ ~ ~ {Fuse:0}
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @e[type=armor_stand,name=drone,tag=drone,limit=1,sort=nearest] run summon minecraft:creeper ~1 ~ ~ {Fuse:0}
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @e[type=armor_stand,name=drone,tag=drone,limit=1,sort=nearest] run summon minecraft:creeper ~-1 ~ ~ {Fuse:0}
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @e[type=armor_stand,name=drone,tag=drone,limit=1,sort=nearest] run summon minecraft:creeper ~ ~ ~1 {Fuse:0}
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @e[type=armor_stand,name=drone,tag=drone,limit=1,sort=nearest] run summon minecraft:creeper ~ ~ ~-1 {Fuse:0}
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @e[type=armor_stand,name=drone,tag=drone,limit=1,sort=nearest] run scoreboard players set @e[type=zombie,distance=..15] waking 25
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run tag @a remove drone
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run scoreboard players set @s drone_timer 0
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run kill @e[tag=drone]
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Detonated.","color":"gray"}]
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run effect give @a[distance=..4] resistance 1 20 true
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run setblock ~ ~2 ~ barrier
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run setblock ~1 ~1 ~ barrier
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run setblock ~-1 ~1 ~ barrier
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run setblock ~ ~1 ~1 barrier
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run setblock ~ ~1 ~-1 barrier
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run scoreboard players set @s drone_barrier 3
execute as @a[scores={recruit=2,drone_phase=2},tag=playing] at @s run scoreboard players set @s drone_phase 0







execute as @a[scores={rclick_special=1..,recruit=2}] at @s run scoreboard players set @s rclick_special 0

# Avoid players spending forever in the drone
# 10 second timer until auto-detonates

scoreboard objectives add drone_timer dummy
scoreboard players add @a drone_timer 0
execute as @e[scores={drone_timer=1..,drone_phase=1}] at @s run scoreboard players add @s drone_timer 1
execute as @e[scores={drone_timer=140}] at @s run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Battery low.","color":"gray"}]
execute as @e[scores={drone_timer=140}] at @s run playsound minecraft:block.note_block.bit player @s ~ ~ ~ 0.5 0.1 0.1
execute as @e[scores={drone_timer=160}] at @s run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Battery low.","color":"gray"}]
execute as @e[scores={drone_timer=160}] at @s run playsound minecraft:block.note_block.bit player @s ~ ~ ~ 0.5 0.1 0.1
execute as @e[scores={drone_timer=180}] at @s run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Battery low.","color":"gray"}]
execute as @e[scores={drone_timer=180}] at @s run playsound minecraft:block.note_block.bit player @s ~ ~ ~ 0.5 0.1 0.1
execute as @e[scores={drone_timer=200..}] at @s run playsound minecraft:test.outage.drone_expire player @s ~ ~ ~ 0.5 1 0.01
execute as @e[scores={drone_timer=200..}] at @s run scoreboard players set @s drone_phase 2


# Wake up nearby zombies while in drone
execute as @e[scores={drone_phase=1},tag=playing] at @s run scoreboard players add @e[type=zombie,distance=..5] waking 5
execute as @e[scores={drone_phase=1,randomd=1},tag=playing] at @s run scoreboard players add @e[type=zombie,distance=..10] waking 1

# Avoid players getting too far away in drone!

execute as @e[scores={drone_phase=1,randomd=1},tag=playing] at @s run execute if entity @e[name=pilot,distance=20..] run playsound minecraft:block.note_block.snare player @s ~ ~ ~ 0.5 0.1 0.1
execute as @e[scores={drone_phase=1,randomd=1},tag=playing] at @s run execute if entity @e[name=pilot,distance=20..] run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Connection Weak!","color":"gray"}]
execute as @e[scores={drone_phase=1,randomd=1},tag=playing] at @s run execute if entity @e[name=pilot,distance=30..] run playsound minecraft:test.outage.drone_expire player @s ~ ~ ~ 0.5 1 0.01
execute as @e[scores={drone_phase=1,randomd=1},tag=playing] at @s run execute if entity @e[name=pilot,distance=30..] run scoreboard players set @s drone_phase 2
execute as @e[scores={drone_phase=1,randomd=5},tag=playing] at @s run execute if entity @e[name=pilot,distance=20..] run playsound minecraft:block.note_block.snare player @s ~ ~ ~ 0.5 0.1 0.1
execute as @e[scores={drone_phase=1,randomd=5},tag=playing] at @s run execute if entity @e[name=pilot,distance=20..] run tellraw @s ["",{"text":"[","color":"dark_gray"},{"text":"Drone","color":"dark_aqua"},{"text":"]","color":"dark_gray"},{"text":" Connection Weak!","color":"gray"}]
execute as @e[scores={drone_phase=1,randomd=5},tag=playing] at @s run execute if entity @e[name=pilot,distance=30..] run playsound minecraft:test.outage.drone_expire player @s ~ ~ ~ 0.5 1 0.01
execute as @e[scores={drone_phase=1,randomd=5},tag=playing] at @s run execute if entity @e[name=pilot,distance=30..] run scoreboard players set @s drone_phase 2